#DEBUG = 1

RCFLAGS =/NOLOGO -r
RESFLAGS =/NOLOGO -t

MAPFILE = nul
DLL_OBJS = \
	   wavemix.OBJ\
	   mixit.obj

DLL_LIBS = sdllcew libw mmsystem

######################## inference rules ####################
.asm.obj:
!ifdef DEBUG
    ml /c /Cp /W3 /Zi /DDEBUG $*.asm
!else
    ml /c /Cp /W3 $*.asm
!endif

all:    wavemix.dll

wavemix.obj: wavemix.h wavemix.def wavemix.c makefile
!ifdef DEBUG
       cl -c -W3 -ASw -Gswc -Od -Zpei -YX -DDEBUG wavemix.c
!else
#   note: should really use -GD for dlls and _export and _loadds to avoid load ds
#         on functions that don't need it  
    cl -c -W3 -ASw -Gswc -Ob1cginots -YX wavemix.c
!endif

mixit.obj: mixit.asm
    ml /c /Cp /W3 /Zi /Fl /Sc /DDEBUG mixit.asm

wavemix.lib: wavemix.def
	implib wavemix.lib wavemix.def

wavemix.res: wavemix.rc
	rc $(RCFLAGS) wavemix.rc

wavemix.dll: $(DLL_OBJS) wavemix.res
!ifdef DEBUG
	Link /MAP /NOD /NOE /CO $(DLL_OBJS), wavemix.dll, wavemix.map, $(DLL_LIBS), wavemix.def
!else
	Link /MAP /NOD /NOE $(DLL_OBJS), wavemix.dll, wavemix.map, $(DLL_LIBS), wavemix.def
!endif
	mapsym wavemix.map
	rc $(RESFLAGS) wavemix.res wavemix.dll


#######  use these commands to profile the dll #######
#
# steps
#  1. nmake prep
#  2. profilew $(PROJ).exe [parameters]
#  3. nmake report
#

Prep:
 prep /ft /p wavemix.dll /ot mixtest.pbt /oi mixtest.pbi

Report:
 prep /it mixtest.pbt /io mixtest.pbo /ot mixtest.pbt
 plist /st mixtest.pbt > mixtest.out

 del mixtest.pbo
 del mixtest.pbi
